#include amxmodx
#if AMXX_VERSION_NUM < 183
	#include colorchat
	#define change_level(%0) server_cmd("changelevel %s", %0)
#endif	

#define STARTTIME	00		// Время начала ночного режима. Тестировал только с 00 часов. Поддежка раннего времени есть, но не проверялось:)
#define ENDTIME		10		// Окончание ночного режима
#define MAP 		"de_dust2_2x2"	// Карта ночного режима
#define AUTORR		30		// Авторестарт карты (sv_restart 1) каждые n раундов. Установите 0 для отключения данной плюшки.

new g_pTimeLimit, g_iOldTime;
new bool:g_bOc;
new szCurMap[32];
#if AUTORR > 0
new g_iRound;
#endif

public plugin_init()
{
#define VERSION "1.0.3"
	register_plugin("Lite NightMode", VERSION, "neygomon");
	register_cvar("lite_nightmode", VERSION, FCVAR_SERVER | FCVAR_SPONLY);
#if AUTORR > 0	
	register_event("TextMsg", 	"eGameCommencing", "a", "2=#Game_Commencing", "2=#Game_will_restart_in");
#endif	
	register_event("HLTV", 		"eRoundStart", "a", "1=0", "2=0");
	
	register_clcmd("say rtv", "RtvHook");
	register_clcmd("say_team rtv", "RtvHook");
	register_clcmd("say /rtv", "RtvHook");
	register_clcmd("say_team rtv", "RtvHook");
	register_clcmd("amx_rtv", "RtvHook");
	
	get_mapname(szCurMap, charsmax(szCurMap));
	
	g_pTimeLimit = get_cvar_pointer("mp_timelimit");
}

public plugin_end()
	if(g_iOldTime) 
		set_pcvar_num(g_pTimeLimit, g_iOldTime);

public client_putinserver(id)
	if(g_bOc) 
		remove_user_flags(id, ADMIN_MAP|ADMIN_VOTE);
#if AUTORR > 0
public eGameCommencing()
	g_iRound = 0;
#endif
public eRoundStart()
{
	static CurHour; time(CurHour);
#if STARTTIME > ENDTIME
	if(STARTTIME <= CurHour || CurHour < ENDTIME)
#else
	if(STARTTIME <= CurHour < ENDTIME)
#endif	
	{	
		if(!strcmp(szCurMap, MAP))
		{
			if(!g_bOc)
			{
				g_bOc = true;
				RemovePlayersFlags();
				set_pcvar_num(g_pTimeLimit, 0);
			}	
#if AUTORR > 0			
			static iRound; iRound = AUTORR - ++g_iRound;
			if(iRound > 0) client_print_color(0, 0, "^1[^4Only ^3%s^1] ^4Через ^3%d ^4раундов авторестарт карты. ^1[ ^4Тек. раунд: ^3%d ^1| ^4Всего: ^3%d^1 ]", MAP, iRound, g_iRound, AUTORR);
			else server_cmd("sv_restart 1");
#endif			
		}
		else change_level(MAP);
	}	
	else if(g_bOc)
	{
		set_pcvar_num(g_pTimeLimit, floatround(get_gametime()) / 60 + 1);
		g_bOc = false;
	}	
}

public RtvHook(id)
{
	if(!g_bOc) return PLUGIN_CONTINUE;
	client_print_color(id, 0, "^1[^4Only ^3%s^1] ^4RTV не работает в ^3Ночном режиме!", MAP);
	return PLUGIN_HANDLED;
}

RemovePlayersFlags()
{
	static players[32], pcount;
	get_players(players, pcount, "ch");
	for(new i; i < pcount; i++)
		remove_user_flags(players[i], ADMIN_MAP|ADMIN_VOTE);
}